# Just a little exercise here :)
# Original idea by Script10k
# (vampire mod beta)

var int friends;
var int enemies;
var int boss_dead;
var int player_dead;

###################
func void main(void) {
    ui_disable_prompt= 1;
    gs_show_corpses= 0;
    co_display= 0;

    friends= 0; player_dead=0;
    enemies= 0; boss_dead=0;

    door_lock 59
    dmsg " "
    dmsg "[l.iON][g.EYEs] - [y.RENEGADE]"
    dmsg " "
    dmsg "KILL THE [r.BOSS]"
    dmsg "KILL ALL [b.ENEMIES]"
    sleep 200

    chr_changeteam 0 Konoko
    fork SpawnBoss WindowNinjaRun Syndicate
    sleep 10; SpawnRenegade FaceNinja Syndicate
    sleep 10; SpawnRenegade fl1_secguard_1 Konoko
    sleep 10; SpawnRenegade FaceNinja2 Syndicate
    sleep 10; SpawnRenegade char_1 Konoko
    sleep 10; SpawnRenegade ambush_ninja_1 Syndicate
    sleep 10; SpawnRenegade fl2_secguard_3 Konoko
    sleep 10; SpawnRenegade creepy_ninja_1 Syndicate
}
###################
func TeleportByTeam(string name, string team) {
    if(team eq Konoko) chr_teleport(name, 12)
    if(team eq Syndicate) chr_teleport(name, 11)
    chr_animate(name, NINCOMteleport_out)
}
func AwarenessByTeam(string name, string team) {
    ai2_forget(name)
    if(team eq Syndicate) ai2_makeaware(name, 0)
    if(team eq Konoko) ai2_makeaware(name, WindowNinjaRun)
}
##################
func SpawnRenegade(string name, string team) {
# not intended to be used for the player
    ai2_spawn(name); chr_unkillable(name, 1);
    chr_ultra_mode(name, 1);
    if(team eq Konoko) {
        friends= friends + 1; give_powerup cell
    }
    if(team eq Syndicate) {
        enemies= enemies + 1; give_powerup ammo
    }
    fork RespawnRenegade(name, team);
}
func RespawnRenegade(string name, string team) {
    chr_changeteam(name, team);
    TeleportByTeam(name, team);
    AwarenessByTeam(name, team);
    chr_inv_reset(name); chr_full_health(name);
    if(team eq Syndicate) chr_givepowerup(name, shield);

    chr_wait_health(name, 1); chr_pain(name, death);
    RegisterBetrayal(team);
    if(team eq Konoko) fork RespawnRenegade(name, Syndicate);
    if(team eq Syndicate) fork RespawnRenegade(name, Konoko);
}
func RegisterBetrayal(string team) {
    sound_impulse_play killkick
    if(team eq Syndicate) {
        ui_flash_element ballistic 0
        enemies= enemies - 1;
        friends= friends + 1;
        give_powerup ammo -1
        give_powerup cell 1
    }
    if(team eq Konoko) {
        ui_flash_element energy 0
        enemies= enemies + 1;
        friends= friends - 1;
        give_powerup ammo 1
        give_powerup cell -1
    }
    if(friends eq 0) {
        if(player_dead) fork LooksLikeWeLost
        else {
            dmsg "[y.GUESS WHAT...]"
            dmsg "[b.NO ONE LEFT TO TRUST]"
            dmsg "DO YOU FEEL LUCKY?"
            ui_flash_element ballistic 1
        }
    }
    if(enemies eq 0) {
        if(boss_dead) fork LooksLikeWeWon
        else dmsg "KILL THE [r.BOSS]"
        ui_flash_element energy 1
    }
}
##################
func SpawnBoss(string name, string team) {
    if(!chr_is_player(name)) ai2_spawn(name);
    chr_givepowerup(name, shield);
    chr_boss_shield(name);
    chr_changeteam(name, team);
    TeleportByTeam(name, team);
    AwarenessByTeam(name, team);
    chr_ultra_mode(name, 1);
    chr_unkillable(name, 1);
    
    chr_wait_health(name, 1);
    chr_pain(name, death);
    chr_inv_reset(name); ai2_kill(name);
    boss_dead=1; dmsg "THE [r.BOSS] IS DEAD"
    if(enemies > 0) dmsg "KILL ALL [b.ENEMIES]"
    else fork LooksLikeWeWon
}
func you_lose{
    player_dead= 1;
    if(friends > 0) GhostifyPlayer
    else fork LooksLikeWeLost
}
func GhostifyPlayer {
    chr_full_health 0
    give_powerup invis -1
    chr_changeteam 0 Switzerland
    dmsg "[y.OOPS! YOU'RE DEAD...]"
    dmsg "[b.BUT... HOPE DIES LAST]"
    dmsg "DO YOU FEEL LUCKY?"
}
##################
func LooksLikeWeWon {
    ai2_allpassive 1
    dmsg "[g.YOU WIN]"
    sleep 120
# I think it sucks to move on to the next level
    lose
}
func LooksLikeWeLost {
    ai2_allpassive 1
    dmsg "[o.YOU LOSE]"
    sleep 120
    lose
}
